#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'rdpprefs.ui'
**
** Created: 2012-08-28T12:51:59
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "rdpprefs.h"

#include <qvariant.h>
#include <kdialog.h>
#include <qgroupbox.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "rdpprefs.ui.h"

/*
 *  Constructs a RdpPrefs as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
RdpPrefs::RdpPrefs( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "RdpPrefs" );
    RdpPrefsLayout = new QVBoxLayout( this, 0, KDialog::spacingHint(), "RdpPrefsLayout"); 

    rdpGroupBox = new QGroupBox( this, "rdpGroupBox" );
    rdpGroupBox->setColumnLayout(0, Qt::Vertical );
    rdpGroupBox->layout()->setSpacing( KDialog::spacingHint() );
    rdpGroupBox->layout()->setMargin( KDialog::marginHint() );
    rdpGroupBoxLayout = new QGridLayout( rdpGroupBox->layout() );
    rdpGroupBoxLayout->setAlignment( Qt::AlignTop );
    spacer8 = new QSpacerItem( 70, 21, QSizePolicy::Fixed, QSizePolicy::Minimum );
    rdpGroupBoxLayout->addItem( spacer8, 1, 0 );

    cmbResolution = new QComboBox( FALSE, rdpGroupBox, "cmbResolution" );
    cmbResolution->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, cmbResolution->sizePolicy().hasHeightForWidth() ) );
    cmbResolution->setMinimumSize( QSize( 280, 0 ) );

    rdpGroupBoxLayout->addMultiCellWidget( cmbResolution, 0, 0, 1, 4 );

    spinWidth = new QSpinBox( rdpGroupBox, "spinWidth" );
    spinWidth->setEnabled( FALSE );
    spinWidth->setMaxValue( 9999 );
    spinWidth->setValue( 800 );

    rdpGroupBoxLayout->addWidget( spinWidth, 1, 2 );

    heightLabel = new QLabel( rdpGroupBox, "heightLabel" );
    heightLabel->setEnabled( FALSE );
    heightLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    rdpGroupBoxLayout->addWidget( heightLabel, 1, 3 );

    spinHeight = new QSpinBox( rdpGroupBox, "spinHeight" );
    spinHeight->setEnabled( FALSE );
    spinHeight->setMaxValue( 9999 );
    spinHeight->setValue( 600 );

    rdpGroupBoxLayout->addWidget( spinHeight, 1, 4 );

    cmbKbLayout = new QComboBox( FALSE, rdpGroupBox, "cmbKbLayout" );
    cmbKbLayout->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, cmbKbLayout->sizePolicy().hasHeightForWidth() ) );
    cmbKbLayout->setMinimumSize( QSize( 280, 0 ) );
    cmbKbLayout->setEditable( FALSE );

    rdpGroupBoxLayout->addMultiCellWidget( cmbKbLayout, 3, 3, 1, 4 );

    layoutLabel = new QLabel( rdpGroupBox, "layoutLabel" );
    layoutLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)1, 0, 0, layoutLabel->sizePolicy().hasHeightForWidth() ) );

    rdpGroupBoxLayout->addWidget( layoutLabel, 3, 0 );

    cbUseKWallet = new QCheckBox( rdpGroupBox, "cbUseKWallet" );
    cbUseKWallet->setEnabled( TRUE );

    rdpGroupBoxLayout->addWidget( cbUseKWallet, 4, 0 );

    resolutionLabel = new QLabel( rdpGroupBox, "resolutionLabel" );
    resolutionLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)1, 0, 0, resolutionLabel->sizePolicy().hasHeightForWidth() ) );

    rdpGroupBoxLayout->addWidget( resolutionLabel, 0, 0 );

    colorDepthLabel = new QLabel( rdpGroupBox, "colorDepthLabel" );
    colorDepthLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)1, 0, 0, colorDepthLabel->sizePolicy().hasHeightForWidth() ) );

    rdpGroupBoxLayout->addWidget( colorDepthLabel, 2, 0 );

    widthLabel = new QLabel( rdpGroupBox, "widthLabel" );
    widthLabel->setEnabled( FALSE );
    widthLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    rdpGroupBoxLayout->addWidget( widthLabel, 1, 1 );

    cmbColorDepth = new QComboBox( FALSE, rdpGroupBox, "cmbColorDepth" );

    rdpGroupBoxLayout->addMultiCellWidget( cmbColorDepth, 2, 2, 1, 4 );
    RdpPrefsLayout->addWidget( rdpGroupBox );

    cbShowPrefs = new QCheckBox( this, "cbShowPrefs" );
    RdpPrefsLayout->addWidget( cbShowPrefs );
    languageChange();
    resize( QSize(449, 177).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( cmbResolution, SIGNAL( activated(int) ), this, SLOT( resolutionChanged(int) ) );
    connect( cmbColorDepth, SIGNAL( activated(int) ), this, SLOT( colorDepth() ) );

    // tab order
    setTabOrder( cmbResolution, spinWidth );
    setTabOrder( spinWidth, spinHeight );
    setTabOrder( spinHeight, cmbColorDepth );
    setTabOrder( cmbColorDepth, cmbKbLayout );
    setTabOrder( cmbKbLayout, cbShowPrefs );

    // buddies
    heightLabel->setBuddy( spinHeight );
    layoutLabel->setBuddy( cmbKbLayout );
    resolutionLabel->setBuddy( cmbResolution );
    colorDepthLabel->setBuddy( cmbKbLayout );
    widthLabel->setBuddy( spinWidth );
}

/*
 *  Destroys the object and frees any allocated resources
 */
RdpPrefs::~RdpPrefs()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void RdpPrefs::languageChange()
{
    rdpGroupBox->setTitle( tr2i18n( "Connection" ) );
    cmbResolution->clear();
    cmbResolution->insertItem( tr2i18n( "Small (640x480)" ) );
    cmbResolution->insertItem( tr2i18n( "Medium (800x600)" ) );
    cmbResolution->insertItem( tr2i18n( "Big (1024x768)" ) );
    cmbResolution->insertItem( tr2i18n( "Custom (...)" ) );
    cmbResolution->insertItem( tr2i18n( "Full Screen (Maximized)" ) );
    cmbResolution->setCurrentItem( 5 );
    QWhatsThis::add( cmbResolution, tr2i18n( "Here you can specify the resolution of the remote desktop. This resolution determines the size of the desktop that will be presented to you." ) );
    QWhatsThis::add( spinWidth, tr2i18n( "This is the width of the remote desktop. You can only change this value manually if you select Custom as desktop resolution above." ) );
    heightLabel->setText( tr2i18n( "H&eight:" ) );
    QWhatsThis::add( spinHeight, tr2i18n( "This is the height of the remote desktop. You can only change this value manually if you select Custom as desktop resolution above." ) );
    cmbKbLayout->clear();
    cmbKbLayout->insertItem( tr2i18n( "Arabic (ar)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Czech (cs)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Danish (da)" ) );
    cmbKbLayout->insertItem( tr2i18n( "German (de)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Swiss German (de-ch)" ) );
    cmbKbLayout->insertItem( tr2i18n( "British English (en-gb)" ) );
    cmbKbLayout->insertItem( tr2i18n( "US English (en-us)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Spanish (es)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Estonian (et)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Finnish (fi)" ) );
    cmbKbLayout->insertItem( tr2i18n( "French (fr)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Belgium (fr-be)" ) );
    cmbKbLayout->insertItem( tr2i18n( "French Canadian (fr-ca)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Swiss French (fr-ch)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Croatian (hr)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Hungarian (hu)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Icelandic (is)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Italian (it)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Japanese (ja)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Lithuanian (lt)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Latvian (lv)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Macedonian (mk)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Dutch (nl)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Belgian Dutch (nl-be)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Norwegian (no)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Polish (pl)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Portuguese (pt)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Brazilian (pt-br)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Russian (ru)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Slovenian (sl)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Swedish (sv)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Thai (th)" ) );
    cmbKbLayout->insertItem( tr2i18n( "Turkish (tr)" ) );
    cmbKbLayout->setCurrentItem( 4 );
    QWhatsThis::add( cmbKbLayout, tr2i18n( "Use this to specify your keyboard layout. This layout setting is used to send the correct keyboard codes to the server." ) );
    layoutLabel->setText( tr2i18n( "&Keyboard layout:" ) );
    cbUseKWallet->setText( tr2i18n( "Use K&Wallet for passwords" ) );
    QWhatsThis::add( cbUseKWallet, tr2i18n( "Enable this option to store your passwords with KWallet." ) );
    resolutionLabel->setText( tr2i18n( "Desktop &resolution:" ) );
    colorDepthLabel->setText( tr2i18n( "Color &depth:" ) );
    widthLabel->setText( tr2i18n( "&Width:" ) );
    cmbColorDepth->clear();
    cmbColorDepth->insertItem( tr2i18n( "Low Color (8 Bit)" ) );
    cmbColorDepth->insertItem( tr2i18n( "High Color (16 Bit)" ) );
    cmbColorDepth->insertItem( tr2i18n( "True Color (24 Bit)" ) );
    cbShowPrefs->setText( tr2i18n( "&Show this dialog again for this host" ) );
    QWhatsThis::add( cbShowPrefs, tr2i18n( "Select this option if you do not want to be asked for the settings when connecting to a host. For hosts with existing profiles these profiles will be taken. New hosts will be configured with the defaults." ) );
}

/****************************************************************************
** RdpPrefs meta object code from reading C++ file 'rdpprefs.h'
**
** Created: Tue Aug 28 12:52:00 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "rdpprefs.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *RdpPrefs::className() const
{
    return "RdpPrefs";
}

QMetaObject *RdpPrefs::metaObj = 0;
static QMetaObjectCleanUp cleanUp_RdpPrefs( "RdpPrefs", &RdpPrefs::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString RdpPrefs::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "RdpPrefs", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString RdpPrefs::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "RdpPrefs", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* RdpPrefs::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUParameter param_slot_0[] = {
	{ 0, &static_QUType_int, 0, QUParameter::Out }
    };
    static const QUMethod slot_0 = {"colorDepth", 1, param_slot_0 };
    static const QUParameter param_slot_1[] = {
	{ "depth", &static_QUType_int, 0, QUParameter::In }
    };
    static const QUMethod slot_1 = {"setColorDepth", 1, param_slot_1 };
    static const QUMethod slot_2 = {"languageChange", 0, 0 };
    static const QUParameter param_slot_3[] = {
	{ "selection", &static_QUType_int, 0, QUParameter::In }
    };
    static const QUMethod slot_3 = {"resolutionChanged", 1, param_slot_3 };
    static const QMetaData slot_tbl[] = {
	{ "colorDepth()", &slot_0, QMetaData::Public },
	{ "setColorDepth(int)", &slot_1, QMetaData::Public },
	{ "languageChange()", &slot_2, QMetaData::Protected },
	{ "resolutionChanged(int)", &slot_3, QMetaData::Protected }
    };
    metaObj = QMetaObject::new_metaobject(
	"RdpPrefs", parentObject,
	slot_tbl, 4,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_RdpPrefs.setMetaObject( metaObj );
    return metaObj;
}

void* RdpPrefs::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "RdpPrefs" ) )
	return this;
    return QWidget::qt_cast( clname );
}

bool RdpPrefs::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: static_QUType_int.set(_o,colorDepth()); break;
    case 1: setColorDepth((int)static_QUType_int.get(_o+1)); break;
    case 2: languageChange(); break;
    case 3: resolutionChanged((int)static_QUType_int.get(_o+1)); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool RdpPrefs::qt_emit( int _id, QUObject* _o )
{
    return QWidget::qt_emit(_id,_o);
}
#ifndef QT_NO_PROPERTIES

bool RdpPrefs::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool RdpPrefs::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
