#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'keycapturewidget.ui'
**
** Created: 2012-08-28T12:52:55
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "keycapturewidget.h"

#include <qvariant.h>
#include <kdialogbase.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KeyCaptureWidget as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KeyCaptureWidget::KeyCaptureWidget( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KeyCaptureWidget" );
    KeyCaptureWidgetLayout = new QGridLayout( this, 1, 1, 0, KDialog::spacingHint(), "KeyCaptureWidgetLayout"); 

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );

    KeyCaptureWidgetLayout->addMultiCellWidget( textLabel1, 0, 0, 0, 2 );
    spacer2 = new QSpacerItem( 112, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    KeyCaptureWidgetLayout->addItem( spacer2, 1, 0 );

    keyLabel = new QLabel( this, "keyLabel" );
    keyLabel->setMinimumSize( QSize( 100, 0 ) );
    keyLabel->setFrameShape( QLabel::Box );
    keyLabel->setLineWidth( 2 );

    KeyCaptureWidgetLayout->addWidget( keyLabel, 1, 1 );
    spacer3 = new QSpacerItem( 111, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    KeyCaptureWidgetLayout->addItem( spacer3, 1, 2 );

    textLabel1_2 = new QLabel( this, "textLabel1_2" );
    textLabel1_2->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );

    KeyCaptureWidgetLayout->addMultiCellWidget( textLabel1_2, 2, 2, 0, 2 );
    languageChange();
    resize( QSize(358, 119).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KeyCaptureWidget::~KeyCaptureWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KeyCaptureWidget::languageChange()
{
    textLabel1->setText( tr2i18n( "Enter a special key or key combination to send to the remote side:" ) );
    keyLabel->setText( QString::null );
    textLabel1_2->setText( tr2i18n( "This function allows you to send a key combination like Ctrl+Alt+Del to the remote side. Press Esc to cancel." ) );
}

/****************************************************************************
** KeyCaptureWidget meta object code from reading C++ file 'keycapturewidget.h'
**
** Created: Tue Aug 28 12:52:55 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "keycapturewidget.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *KeyCaptureWidget::className() const
{
    return "KeyCaptureWidget";
}

QMetaObject *KeyCaptureWidget::metaObj = 0;
static QMetaObjectCleanUp cleanUp_KeyCaptureWidget( "KeyCaptureWidget", &KeyCaptureWidget::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString KeyCaptureWidget::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "KeyCaptureWidget", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString KeyCaptureWidget::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "KeyCaptureWidget", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* KeyCaptureWidget::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUMethod slot_0 = {"languageChange", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "languageChange()", &slot_0, QMetaData::Protected }
    };
    metaObj = QMetaObject::new_metaobject(
	"KeyCaptureWidget", parentObject,
	slot_tbl, 1,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_KeyCaptureWidget.setMetaObject( metaObj );
    return metaObj;
}

void* KeyCaptureWidget::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "KeyCaptureWidget" ) )
	return this;
    return QWidget::qt_cast( clname );
}

bool KeyCaptureWidget::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: languageChange(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool KeyCaptureWidget::qt_emit( int _id, QUObject* _o )
{
    return QWidget::qt_emit(_id,_o);
}
#ifndef QT_NO_PROPERTIES

bool KeyCaptureWidget::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool KeyCaptureWidget::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
